package at.ac.tuwien.dbai.alternation.examples;

public class CatAndMouseTest {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Graph<Integer> graph=new Graph<Integer>();

		int n=10;
		for (int i=1; i<=n; i++){
			graph.addNode(i);
		}

		graph.addEdge(1, 2);
		graph.addEdge(1, 3);
		graph.addEdge(2, 1);
		graph.addEdge(2, 6);
		graph.addEdge(3, 4);
		graph.addEdge(4, 1);
		graph.addEdge(4, 5);
		graph.addEdge(5, 6);
		graph.addEdge(5, 7);
		graph.addEdge(5, 8);
		graph.addEdge(6, 8);
		graph.addEdge(7, 8);
		graph.addEdge(7, 9);
		graph.addEdge(8, 7);
		graph.addEdge(8, 10);
		graph.addEdge(9, 10);


		Graph.Node<Integer> mouseStart = graph.get(1);
		Graph.Node<Integer> catStart = graph.get(2);
		Graph.Node<Integer> goal = graph.get(10);

		CatAndMouse acyclicAtm = new CatAndMouse();

		System.out.println("acyclic ATM: ");
		System.out.println(acyclicAtm.compute(graph,catStart, mouseStart,goal));
		System.out.println("#ComputationNodes: "+ acyclicAtm.getComputationTree().size());
		if (acyclicAtm.getComputationTree().size()<50) System.out.println(acyclicAtm.getComputationTree());

		CatAndMouse2 cyclicAtm = new CatAndMouse2();
		System.out.println("cyclic ATM: ");
		System.out.println(cyclicAtm.compute(graph,catStart, mouseStart,goal));
		System.out.println("#ComputationNodes: "+ cyclicAtm.getComputationTree().size());
		if (cyclicAtm.getComputationTree().size()<50) System.out.println(cyclicAtm.getComputationTree());

		CatAndMouse3 simpleAtm = new CatAndMouse3();
		System.out.println("simple ATM: ");
		System.out.println(simpleAtm.compute(graph,catStart, mouseStart,goal));
		//System.out.println("#ComputationNodes: "+ simpleAtm.getComputationTree().size());
		//if (simpleAtm.getComputationTree().size()<50) System.out.println(simpleAtm.getComputationTree());
	}

}
