package at.ac.tuwien.dbai.alternation.examples;

import at.ac.tuwien.dbai.alternation.examples.Circuit.GateTypes;

public class MCVPTest {


	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Circuit circuit= new Circuit();
		circuit.addGate(0, GateTypes.INPUT);
		circuit.addGate(1, GateTypes.INPUT);
		circuit.addGate(2, GateTypes.INPUT);
		circuit.addGate(3, GateTypes.INPUT);
		circuit.addGate(4, GateTypes.AND);
		circuit.addGate(5, GateTypes.OR);
		circuit.addGate(6, GateTypes.AND);
		circuit.addGate(7, GateTypes.OR);
		circuit.addGate(8, GateTypes.OR);
		circuit.addGate(9, GateTypes.OUTPUT);
		circuit.addGate(10, GateTypes.OUTPUT);
		
		circuit.connect(circuit.getGate(0),circuit.getGate(4));
		circuit.connect(circuit.getGate(1),circuit.getGate(4));
		circuit.connect(circuit.getGate(1),circuit.getGate(5));
		circuit.connect(circuit.getGate(2),circuit.getGate(5));
		circuit.connect(circuit.getGate(2),circuit.getGate(6));
		circuit.connect(circuit.getGate(3),circuit.getGate(6));
		
		
		circuit.connect(circuit.getGate(4),circuit.getGate(7));
		circuit.connect(circuit.getGate(3),circuit.getGate(7));
		circuit.connect(circuit.getGate(4),circuit.getGate(8));
		circuit.connect(circuit.getGate(6),circuit.getGate(8));
		
		circuit.connect(circuit.getGate(7),circuit.getGate(9));
		circuit.connect(circuit.getGate(8),circuit.getGate(9));
		circuit.connect(circuit.getGate(5),circuit.getGate(10));
		MCVP atm = new MCVP();
		boolean[] input = new boolean[]{false,true,true,false};
		System.out.println(atm.compute(circuit,input,0));
		System.out.println("#ComputationNodes: "+ atm.getComputationTree().size());
		if (atm.getComputationTree().size()<50) System.out.println(atm.getComputationTree());
	}

}
