package at.ac.tuwien.dbai.alternation.examples;

import java.util.HashMap;
import java.util.Map;

public class AlternatingTuringMachineTest {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		TransitionFunction delta = new TransitionFunction();
		delta.addRule('a','b',1, 'b', 1, 1, 0);
		delta.addRule('a','b',1, 'b', 2, 1, 0);
		
		delta.addRule('a','b',2, 'b', 3, 1, 0);
		delta.addRule('a','b',2, 'b', 1, 1, 0);
		
		delta.addRule('c','b',1, 'b', 2, 1, 0);
		delta.addRule('c','b',1, 'b', 1, 1, 0);
		
		delta.addRule('c','b',2, 'b', 2, 1, 0);
		
		delta.addRule('e','b',1, 'b', 4, 0, 0);
		delta.addRule('e','b',2, 'b', 4, 0, 0);
		
		
		AlternatingTuringMachine atm = new AlternatingTuringMachine();
		char[] inputtape = new char[]{'a','c','a','c','c','c','c','a','c','a','a','c','a','c','a','e'};
		int C=27;
		Map<Integer,Character> stateType = new HashMap<Integer,Character>();
		stateType.put(1, 'E');
		stateType.put(2, 'F');
		stateType.put(3, 'A');
		stateType.put(4, 'R');
		int initialState=1;
		
		
		System.out.println(atm.compute(inputtape,delta,stateType,initialState,C));
		System.out.println("#ComputationNodes: "+ atm.getComputationTree().size());
		System.out.println(atm.getComputationTree());
	}

}
